--===============================================
--==          Portal SENT by Mahalis           ==
--==           <mahalis@gmail.com>             ==
--==            Released 3/28/07               ==
--==                                           ==
--==    I worked hard on this code. You are    ==
--==    welcome to learn from (NOT copy) it,   ==
--==    and modify it for personal use only.   ==
--==    Please do not redistribute this or     ==
--==       any modified version thereof.       ==
--==          Thanks, and have fun.            ==
--==                                           ==
--===============================================

include('shared.lua')

local sprite = Material("sprites/portal")
local blueBorder = Material("sprites/blueborder")
local redBorder = Material("sprites/redborder")

local bluTex = GetRenderTarget("bluPortal",512,512,false)
local redTex = GetRenderTarget("redPortal",512,512,false)

function ENT:Think()
	local targ = (self.Entity:GetNetworkedBool("blue")) and bluTex or redTex
	sprite:SetMaterialTexture("$basetexture",targ)
	local opos = self.Entity:GetNetworkedVector("opos")
	local oang = self.Entity:GetNetworkedAngle("oang")
	local eyePos = LocalPlayer():GetEyeTrace().StartPos
	local camData = {}
	camData.origin = opos
	local eyeOff = (eyePos - self.Entity:GetPos()):Angle() - self.Entity:GetAngles()
	camData.angles = oang + eyeOff
	if math.abs(oang:Forward():Dot(Vector(0,0,1))) < 0.7 then -- if it's not vertical
		camData.angles = camData.angles - (2*camData.angles.pitch * Angle(1,0,0))
	end
	local fov = 2*math.Rad2Deg(math.atan(83.4185/eyePos:Distance(self.Entity:GetPos())))
	if fov < 90 then fov = 90 end
	camData.fov = fov
	camData.w=512
	camData.h=512
	camData.x=0
	camData.y=0
	
	local oldRT = render.GetRenderTarget()
	render.SetRenderTarget(targ)
	render.Clear(0,255,0,255)
	render.SetViewPort(0,0,512,512)
	render.RenderView(camData)
	render.SetRenderTarget(oldRT)
	render.SetViewPort(0,0,ScrW(),ScrH())
end

function ENT:Draw()
	local targ = (self.Entity:GetNetworkedBool("blue")) and bluTex or redTex
	sprite:SetMaterialTexture("$basetexture",targ)
	render.SetMaterial(sprite)
	
	local pos = self.Entity:GetPos()+self.Entity:GetAngles():Forward()*.2
	local rt = self.Entity:GetAngles():Right()
	local up = self.Entity:GetAngles():Up()
	render.DrawQuad(pos + 64*rt + 64*up, pos - 64*rt + 64*up, pos - 64*rt - 64*up, pos + 64*rt - 64*up)
	
	pos = pos + self.Entity:GetAngles():Forward()*.2
	render.SetMaterial(self.Entity:GetNetworkedBool("blue") and blueBorder or redBorder)
	render.DrawQuad(pos + 64*rt + 64*up, pos - 64*rt + 64*up, pos - 64*rt - 64*up, pos + 64*rt - 64*up,col)
end