--===============================================
--==          Portal SENT by Mahalis           ==
--==           <mahalis@gmail.com>             ==
--==            Released 3/28/07               ==
--==                                           ==
--==    I worked hard on this code. You are    ==
--==    welcome to learn from (NOT copy) it,   ==
--==    and modify it for personal use only.   ==
--==    Please do not redistribute this or     ==
--==       any modified version thereof.       ==
--==          Thanks, and have fun.            ==
--==                                           ==
--===============================================

AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include('shared.lua')

ENT.othrPortal = nil -- other portal
ENT.incomingVel = nil -- velocity of whatever hit the portal (physics)

ENT.betAng = nil

function ENT:Initialize()
	-- standard physics setup
	self.Entity:SetModel("models/props_borealis/borealis_door001a.mdl") -- only use I've ever found for this prop, by the way :D
	self.Entity:PhysicsInit(SOLID_VPHYSICS)
	self.Entity:SetMoveType(MOVETYPE_VPHYSICS)
	self.Entity:SetSolid(SOLID_VPHYSICS)
	local phy = self.Entity:GetPhysicsObject()
	if phy:IsValid() then phy:EnableMotion(false) end
	self.Entity:DrawShadow(false)
end

function ENT:SetKind(kind)
	self.Kind = kind
end

function ENT:SetOtherPortal(p)
	self.othrPortal = p
	self.betAng = p:GetAngles() - self.Entity:GetAngles()
	self.Entity:SetNetworkedVector("opos",p:GetPos())
	self.Entity:SetNetworkedAngle("oang",p:GetAngles())
end

function ENT:PhysicsCollide(data,physobj)
	if data.HitEntity:EntIndex() != 0 then
		self.incomingVel = data.TheirOldVelocity
		local ent = data.HitEntity
		self:Port(ent)
	end
end

function ENT:Port(other)
	local toPort = self.othrPortal
	if toPort != nil && !(other:GetTable().justPortaled) && other then
		local oPh = other:GetPhysicsObject()
		if oPh:IsValid() then
			local angDiff = self.betAng
			local othOff = other:GetPos() - self.Entity:GetPos()
			local nuPos = toPort:GetPos() + self:VecByAng(othOff,angDiff) + toPort:GetAngles():Forward()*3
			local meVert = self:CheckVertical(self.Entity:GetAngles())
			local oVert = self:CheckVertical(toPort:GetAngles())
			local nuVel = (self:VecByAng(self.incomingVel,angDiff)) * (((meVert || oVert) && !(meVert && oVert)) and 1 or -1)
			if !other:IsPlayer() then -- it's a physics object
				if self:SubAxis(othOff,self.Entity:GetAngles():Forward()):Length() < 60 then -- make sure it's within range
					local sol = other:GetSolid()
					other:SetSolid(SOLID_NONE)
					oPh:EnableGravity(false)
					oPh:EnableDrag(false)
						oPh:SetVelocity(nuVel)
						other:SetPos(nuPos)
						other:SetAngles(other:GetAngles() + angDiff)
						oPh:SetPos(nuPos)
						other:GetTable().justPortaled = true
					other:SetSolid(sol)
					oPh:EnableGravity(true)
					oPh:EnableDrag(true)
				end
			else -- it's a player
				if self.incomingVel:Length() > 338 then
					if other:Health() < 100 then other:SetHealth(other:Health() + 10) end
				end
				local othOffset = self:SubAxis(othOff,self.Entity:GetAngles():Forward() * -1):Length()
				local extraOut = 8
				if meVert && !oVert then
					extraOut = 32
				elseif toPort:GetAngles():Forward():Dot(Vector(0,0,-1)) > 0.8 then
					if !meVert then
						extraOut = 64
					else
						extraOut = 80
					end
				end
				if othOffset <= 68 then
					other:SetPos(nuPos + toPort:GetAngles():Forward()*extraOut)
					other:SetVelocity(nuVel)
					local newEyes = other:GetAngles() + angDiff + Angle(0,180,0)
					newEyes.roll = 0
					other:SetEyeAngles(newEyes)
					other:GetTable().justPortaled = true
				end
			end
		end
	end
end


function ENT:EndTouch(other)
	other:GetTable().justPortaled = false
end

function ENT:CheckVertical(ang)
	return math.abs(ang:Forward():Dot(Vector(0,0,1))) > 0.8
end

function ENT:Die()
	self.Entity:Remove()
end