--===============================================
--==        Portal Gun SWEP by Mahalis         ==
--==           <mahalis@gmail.com>             ==
--==            Released 3/28/07               ==
--==                                           ==
--==    I worked hard on this code. You are    ==
--==    welcome to learn from (NOT copy) it,   ==
--==    and modify it for personal use only.   ==
--==    Please do not redistribute this or     ==
--==       any modified version thereof.       ==
--==          Thanks, and have fun.            ==
--==                                           ==
--===============================================

BLUE = 0
RED = 1

PORTAL_HEIGHT = 128
PORTAL_WIDTH = 72

SWEP.Author = "mahalis"
SWEP.Contact = "mahalis@gmail.com"
SWEP.Purpose = ""
SWEP.Instructions = "Left-click to make a blue portal, right-click for a red one."

SWEP.Spawnable = true;
SWEP.AdminSpawnable = true;

SWEP.ViewModel = "models/weapons/v_physcannon.mdl"
SWEP.WorldModel = "models/weapons/w_physics.mdl"
 
SWEP.Primary.ClipSize = -1
SWEP.Primary.DefaultClip = -1
SWEP.Primary.Automatic = false
SWEP.Primary.Ammo = "none"
  
SWEP.Secondary.ClipSize = -1
SWEP.Secondary.DefaultClip = -1
SWEP.Secondary.Automatic = false
SWEP.Secondary.Ammo = "none"

SWEP.portalB = nil
SWEP.portalR = nil

local ShootSound = Sound("NPC_CombineBall.Launch")

function SWEP:PrimaryAttack()
	self:Portalfy(BLUE)
end

function SWEP:SecondaryAttack()
	self:Portalfy(RED)
end

function SWEP:Portalfy(kind)
	local trd = {}
	trd.start = self.Owner:GetShootPos()
	trd.endpos = trd.start + self.Owner:GetAimVector()*4000
	trd.filter = {self.portalR,self.portalB}
	trd.mask = MASK_SOLID_BRUSHONLY
	
	local tr = util.TraceLine(trd)
	if !(tr.Hit && tr.Entity) then return false end
	self.Weapon:EmitSound(ShootSound)
	self.BaseClass.ShootEffects(self)
	if(!SERVER) then return end
	local nuPortal;
	nuPortal = ents.Create("m_portal")
	
	
	-- check for world collisions
	local noPortal = false
	local phaseHit = false
	local xMoved = 0
	local yMoved = 0
	local normAng = tr.HitNormal:Angle() -- hitnormal angle
	local sPos = tr.HitPos + tr.HitNormal -- starting position of portal
	
	-- EDGES
	local trc;
	
	-- vertical
	trc = util.TraceLine(self:MakeTrace(sPos,normAng:Up() * -1 * PORTAL_HEIGHT * 0.5))
	if trc.Hit then
		yMoved = (1 - trc.Fraction) * PORTAL_HEIGHT * 0.5
		sPos = sPos + yMoved * normAng:Up()
	end
	trc = util.TraceLine(self:MakeTrace(sPos,normAng:Up() * PORTAL_HEIGHT * 0.5))
	if trc.Hit then
		if yMoved > 0 then
			noPortal = true
		else
			yMoved = (1 - trc.Fraction) * PORTAL_HEIGHT * -0.5
			sPos = sPos + yMoved * normAng:Up()
		end
	end
	
	if !noPortal then
		-- horizontal
		trc = util.TraceLine(self:MakeTrace(sPos,normAng:Right() * PORTAL_WIDTH * 0.5))
		phaseHit = false
		if trc.Hit then
			xMoved = (1 - trc.Fraction) * PORTAL_WIDTH * -0.5
			sPos = sPos + xMoved * normAng:Right()
		end
		trc = util.TraceLine(self:MakeTrace(sPos,normAng:Right() * PORTAL_WIDTH * 0.5 * -1))
		if trc.Hit then
			if xMoved < 0 then
				noPortal = true
			else
				xMoved = (1 - trc.Fraction) * PORTAL_WIDTH * 0.5;
				sPos = sPos + xMoved * normAng:Right()
			end
		end
		
		-- CORNERS
		-- trace back a step; if there's no world, then trace inwards until you hit it; if that's less than the portal's already moved in the opposite direction, then move it
		local cornPos;
		
		-- top
		cornPos = sPos + normAng:Up() * PORTAL_HEIGHT * 0.5
		trc = util.TraceLine(self:MakeTrace(cornPos,normAng:Forward() * -2))
		if !trc.Hit then
			--player.GetByID(1):PrintMessage(HUD_PRINTCENTER,"No world behind top edge")
			trc = util.TraceLine(self:MakeTrace(cornPos - 2 * normAng:Forward(),normAng:Up() * (PORTAL_HEIGHT - yMoved) * -1))
			if trc.Hit then
				yMoved = (1 - trc.Fraction) * PORTAL_HEIGHT * -0.5
				sPos = sPos + yMoved * normAng:Up()
			end
		end
		-- bottom
		cornPos = sPos + normAng:Up() * PORTAL_HEIGHT * -0.5
		trc = util.TraceLine(self:MakeTrace(cornPos,normAng:Forward() * -2))
		if !trc.Hit then
			--player.GetByID(1):PrintMessage(HUD_PRINTCENTER,"No world behind bottom edge")
			trc = util.TraceLine(self:MakeTrace(cornPos - 2 * normAng:Forward(),normAng:Up() * (PORTAL_HEIGHT - yMoved)))
			if trc.Hit then
				if yMoved < 0 then
					noPortal = true
				else
					yMoved = (1 - trc.Fraction) * PORTAL_HEIGHT * 0.5
					sPos = sPos + yMoved * normAng:Up()
				end
			end
		end
		
	end
	
	if noPortal then return end
	
	nuPortal:SetPos(sPos + tr.HitNormal)
	local nupAng = tr.HitNormal:Angle()
	if math.abs(tr.HitNormal:Dot(Vector(0,0,1))) > 0.9 then nupAng.roll = self.Owner:GetAimVector():Angle().yaw end
	nuPortal:SetAngles(nupAng)
	
	nuPortal:Spawn()
	nuPortal:Activate()
	nuPortal:SetKind(kind)
	if kind == BLUE then
		if self.portalB != nil then self.portalB:Die() end
		self.portalB = nuPortal
		nuPortal:SetNetworkedBool("blue",true,true)
	else
		if self.portalR != nil then self.portalR:Die() end
		self.portalR = nuPortal
		nuPortal:SetNetworkedBool("blue",false,true)
	end
	if self.portalB != nil && self.portalR != nil then
		self.portalB:SetOtherPortal(self.portalR)
		self.portalR:SetOtherPortal(self.portalB)
	end
end

function SWEP:OnRemove()
	self:Reload()
end

function SWEP:MakeTrace(start,off)
	local trace = {}
	trace.start = start
	trace.endpos = start + off
	trace.filter = {self.portalR,self.portalB}
	trace.mask = MASK_ALL
	return trace
end

function SWEP:Reload()
	if self.portalR != nil then
		self.portalR:Die()
		self.portalR = nil
	end
	if self.portalB != nil then
		self.portalB:Die()
		self.portalB = nil
	end
end

function SWEP:Think()

end

